package net.mc_pandacraft.java.plugin.pandacraftutils.commands;

import java.util.List;
import java.util.Random;

import net.mc_pandacraft.java.plugin.pandacraftutils.config.ConfigManager;
import net.mc_pandacraft.java.plugin.pandacraftutils.config.elements.WorldBorderConfigEntry;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayer;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayerManager;
import net.mc_pandacraft.java.util.TimeUtil;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import com.google.common.collect.ImmutableList;

public class CommandGhost extends AbstractCommandExecutor {
	private static final long timeBetweenThorCommand = 5000;
	private long timeLastThorCommand = System.currentTimeMillis();
	
	

	public CommandGhost() {
		super("ghost");
	}
	
	
	
	
	
	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label,
			String[] args) {
		
		if (!(sender instanceof Player)) {
			sender.sendMessage(ChatColor.RED+"Vous devez être en ligne pour faire cette commande");
			return true;
		}
		
		Player player = (Player) sender;
		
		if (args.length == 0) {
			showHelp(player);
			return true;
		}

		if (args.length >= 1 && args[0].equalsIgnoreCase("thor")) {
			onCommandThor(player);
			return true;
		}
		if (args.length >= 1 && args[0].equalsIgnoreCase("particle")) {
			onCommandParticle(player);
			return true;
		}
		
		
		
		
		
		

		// on arrive ici si aucune des sous commandes correspond à celle tapée
		sender.sendMessage(ChatColor.RED+"Mauvaise utilisation de la commande. Faites "+ChatColor.GRAY+"/ghost"+ChatColor.RED+" pour connaitre l'utilisation");
		
		
		return true;
	}






	private void showHelp(Player player) {
		player.sendMessage(new String[] {
				ChatColor.GOLD+"---------- Commande /ghost ----------",
				ChatColor.GRAY+"/ghost thor"+ChatColor.GOLD+" produire de l'orage sur l'intégralité du serveur",
				ChatColor.GRAY+"/ghost particle"+ChatColor.GOLD+" produit un effet de potion autour de vous",
				ChatColor.GOLD+"------------------------------------------"
		});
		
		
	}
	
	
	

	public static final List<String> FIRST_ARG = ImmutableList.of("thor", "particle");

	@Override
	public List<String> onTabComplete(CommandSender sender, Command cmd, String alias, String[] args) {
		
		if (args.length == 1) {
			return getTabProposalFromToken(args[0], FIRST_ARG);
		}
		
		return NO_PROPOSAL;
	}
	
	
	
	
	private void onCommandThor(Player player) {
		
		long timeSinceLastThorCommand = System.currentTimeMillis() - timeLastThorCommand;
		
		if (timeSinceLastThorCommand < timeBetweenThorCommand) {
			player.sendMessage(ChatColor.RED+"Veuillez patienter "+TimeUtil.durationToString(timeBetweenThorCommand - timeSinceLastThorCommand)+" avant de refaire cette commande");
		}
		
		timeLastThorCommand = System.currentTimeMillis();
		
		
		
		
		List<World> worlds = plugin.getServer().getWorlds();
		
		Random r = new Random();
		
		for (World w : worlds) {
			
			WorldBorderConfigEntry config = ConfigManager.getInstance().worldBorderConfig.getEntry(w);
			if (config == null)
				continue;
			
			int nbStrike = r.nextInt(3)+1;
			
			for (int i=0; i<nbStrike; i++) {
				
				// l'orage sera localisé à un endroit aléatoire à l'intérieur des WorldBorders
				double locX = r.nextDouble()*(config.getMaxX()-config.getMinX())+config.getMinX();
				double locY = r.nextDouble()*255;
				double locZ = r.nextDouble()*(config.getMaxZ()-config.getMinZ())+config.getMinZ();
				
				int nbTickBeforeStrike = r.nextInt(20);
				
				Location loc = new Location(w, locX, locY, locZ);
				
				plugin.getServer().getScheduler().runTaskLater(plugin, new Runnable() {
					Location loc;
					@Override
					public void run() {
						loc.getWorld().strikeLightningEffect(loc);
					}

					public Runnable init(Location l) {
						loc = l;
						return this;
					}
					
				}.init(loc), nbTickBeforeStrike);
				
			}
		}
		
		player.sendMessage(ChatColor.GREEN+"L'orage vient de gronder sur tout le serveur.");
	}
	
	
	



	private void onCommandParticle(Player player) {
		
		OnlinePlayer op = OnlinePlayerManager.get(player);
		
		boolean activated = op.toggleGhostParticle();
		
		if (activated)
			player.sendMessage(ChatColor.GREEN+"Activation des particules fantômes");
		else
			player.sendMessage(ChatColor.GREEN+"Désactivation des particules fantômes");
		
		
		
	}

	
	
	

}
