package net.mc_pandacraft.java.plugin.pandacraftutils.commands;

import net.mc_pandacraft.java.plugin.pandacraftutils.modules.PrivateMessagesManager.MessageSender;
import net.mc_pandacraft.java.plugin.pandacraftutils.modules.PrivateMessagesManager.MessageSendingException;
import net.mc_pandacraft.java.plugin.pandacraftutils.players.OnlinePlayerManager;

import org.bukkit.ChatColor;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class CommandTell extends AbstractCommandExecutor {
	
	public CommandTell() {
		super("tell");
	}

	@Override
	public boolean onCommand(CommandSender sender, Command cmd, String label,
			String[] args) {
		
		if (args.length == 0 && sender instanceof Player) {
			plugin.privateMessagesManager.displayUnreadMessages((Player)sender);
			return true;
		}
		else if (args.length == 0) {
			sender.sendMessage(ChatColor.RED+"Seul un joueur en ligne peut lire ses messages non lus.");
			return false;
		}
		
		
		
		if (args.length >= 2) {
			onCommandSend(sender, args[0], getLastParam(args, 1));
			return true;
		}
		
		
		
		
		
		return false;
	}
	
	
	
	private void onCommandSend(CommandSender sender, String target, String message) {
		
		if (sender instanceof Player && OnlinePlayerManager.get((Player) sender).getEssentialsUser().isMuted()) {
			sender.sendMessage(ChatColor.RED+"Vous ne pouvez pas envoyer de message quand vous êtes muet");
			return;
		}
		
		try {
			plugin.privateMessagesManager.inputMessage(new MessageSender(sender), target, message);
		} catch (MessageSendingException e) {
			sender.sendMessage(ChatColor.RED+e.getMessage());
		}
		
	}
	
	

}
