package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

import java.sql.SQLException;

public class MPGroupUserElement extends SQLElement {
	
	private int groupId;
	private String playerName;

	
	public MPGroupUserElement(int gId, String pName) {
		super("pandacraft_mp_group_user");
		setGroupId(gId);
		setPlayerName(pName);
	}
	
	protected MPGroupUserElement(int id, int gId, String pName) {
		super("pandacraft_mp_group_user", id);
		setGroupId(gId);
		setPlayerName(pName);
	}

	
	
	@Override
	protected String[] getValues() {
		return new String[] {
				Integer.toString(groupId),
				playerName
		};
	}

	@Override
	protected String[] getFieldsName() {
		return new String[] {
				"groupId",
				"playerName"
		};
	}
	
	
	
	
	
	
	
	public int getGroupId() { return groupId; }
	public String getPlayerName() { return playerName; }

	public void setGroupId(int gId) { groupId = gId; }
	public void setPlayerName(String playerName) {
		if (playerName == null)
			throw new NullPointerException();
		this.playerName = playerName;
	}
	
	
	
	
	
	
	public MPWebSessionElement getWebSessionData() throws SQLException {
		return ((MPWebSessionTable)ORM.getTable("mp_web_session"))
				.getFirst("playerName LIKE '"+getPlayerName()+"'", "id ASC");
	}
	
	
	

}
