package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

import java.sql.ResultSet;
import java.sql.SQLException;

import net.mc_pandacraft.java.plugin.pandacraftutils.commands.AbstractCommandExecutor;

public class MPGroupUserTable extends SQLTable<MPGroupUserElement> {
	
	public MPGroupUserTable() throws SQLException {
		super("pandacraft_mp_group_user");
	}

	@Override
	protected String createTableParameters() {
		return "id INT AUTO_INCREMENT PRIMARY KEY,"
				+ "groupId INT NOT NULL,"
				+ "playerName VARCHAR(16) NOT NULL";
	}

	@Override
	protected MPGroupUserElement getElementInstance(ResultSet sqlResult)
			throws SQLException {
		return new MPGroupUserElement(
				sqlResult.getInt("id"),
				sqlResult.getInt("groupId"),
				sqlResult.getString("playerName"));
	}
	
	
	
	public MPGroupUserElement getPlayerInGroup(MPGroupElement group, String player) throws SQLException {
		if (!AbstractCommandExecutor.isValidPlayerName(player))
			return null;
		return getFirst("groupId = "+group.getId()+" AND playerName = '"+player+"'", "id");
	}

}
