package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

public class MPWebSessionElement extends SQLElement {
	
	private String playerName;
	private long lastWebActivity;
	private boolean isInGameOnline;
	private String playerDisplayName;

	public MPWebSessionElement(String pName, long lastWebAct, boolean onlineIG, String dispName) {
		super("pandacraft_mp_web_session");
		setPlayerName(pName);
		setLastWebActivity(lastWebAct);
		setInGameOnline(onlineIG);
		setPlayerDisplayName(dispName);
	}
	
	protected MPWebSessionElement(int id, String pName, long lastWebAct, boolean onlineIG, String dispName) {
		super("pandacraft_mp_web_session", id);
		setPlayerName(pName);
		setLastWebActivity(lastWebAct);
		setInGameOnline(onlineIG);
		setPlayerDisplayName(dispName);
	}

	@Override
	protected String[] getValues() {
		return new String[] {
				playerName,
				Long.toString(lastWebActivity),
				(isInGameOnline)?"1":"0",
				playerDisplayName
		};
	}

	@Override
	protected String[] getFieldsName() {
		return new String[] {
				"playerName",
				"lastWebActivity",
				"isInGameOnline",
				"playerDisplayName"
		};
	}

	public String getPlayerName() { return playerName; }
	public long getLastWebActivity() { return lastWebActivity; }
	public boolean isInGameOnline() { return isInGameOnline; }
	public String getPlayerDisplayName() { return playerDisplayName; }
	
	
	
	public void setPlayerName(String pName) {
		if (pName == null)
			throw new NullPointerException();
		playerName = pName;
	}

	public void setLastWebActivity(long lastWebAct) { lastWebActivity = lastWebAct; }
	
	public void setInGameOnline(boolean onlineIG) { isInGameOnline = onlineIG; }
	
	public void setPlayerDisplayName(String dispName) {
		if (dispName == null)
			throw new NullPointerException();
		playerDisplayName = dispName;
	}

}
