package net.mc_pandacraft.java.plugin.pandacraftutils.data_model;

import java.sql.ResultSet;
import java.sql.SQLException;

public class StaffTicketTable extends SQLTable<StaffTicketElement> {

	
	public StaffTicketTable() throws SQLException {
		super("pandacraft_staff_ticket");
	}

	@Override
	protected String createTableParameters() {
		return "id INT AUTO_INCREMENT PRIMARY KEY,"
				+ "playerName VARCHAR(16) NOT NULL,"
				+ "message VARCHAR(1024) NOT NULL,"
				+ "creationTime BIGINT NOT NULL,"
				+ "staffPlayer VARCHAR(16) NULL,"
				+ "locWorld VARCHAR(64) NOT NULL,"
				+ "locX DOUBLE NOT NULL,"
				+ "locY DOUBLE NOT NULL,"
				+ "locZ DOUBLE NOT NULL";
	}

	@Override
	protected StaffTicketElement getElementInstance(ResultSet sqlResult)
			throws SQLException {
		StaffTicketElement el = new StaffTicketElement(
				sqlResult.getInt("id"),
				sqlResult.getString("playerName"),
				sqlResult.getString("message"),
				sqlResult.getLong("creationTime"),
				sqlResult.getString("locWorld"),
				sqlResult.getDouble("locX"),
				sqlResult.getDouble("locY"),
				sqlResult.getDouble("locZ"));
		el.setStaffPlayer(sqlResult.getString("staffPlayer"));
		
		return el;
	}

}
